! **********************************************************************+
MODULE messy_main_data_si
! **********************************************************************+

  ! THIS MODULE PROVIDES THE LINK BETWEEN THE BASMODEL (BML) AND THE BMIL

  USE messy_main_constants_mem, ONLY: dp

  IMPLICIT NONE
  PUBLIC
 
  ! THESE ARE THE TRACER SET DATA DIMENSIONS, E.G. THE GRID
  INTEGER, PARAMETER :: nproma  = 5
  INTEGER, PARAMETER :: npromz  = 5
  INTEGER, PARAMETER :: nlev    = 2
  INTEGER, PARAMETER :: ngpblks = 10
  !
  INTEGER, PARAMETER :: kproma  = nproma

  ! LENGTH OF THE INTEGRATION TIME STEP
  REAL(DP), PARAMETER :: time_step_len = 1.0_dp ! [s]

  ! THIS IS THE FLAG FOR THE RESTART MODE, WHICH IS NOT IMPLEMENTED IN
  ! THIS BOXMODEL
  LOGICAL, PARAMETER :: lresume = .FALSE.

  ! THIS IS THE LOOP VARIABLE FOR THE 'LOCAL LOOP' ALONG THE 3rd DIMENSION
  INTEGER, SAVE :: jrow

  ! PHYSICAL DATA TO BE PROVIDED BY THE BASE MODEL (FOR TRACER_PDEF)
  REAL(DP), DIMENSION(kproma, nlev+1, ngpblks), SAVE :: pressi_3d    ! [Pa]
  REAL(DP), DIMENSION(kproma, ngpblks),         SAVE :: gboxarea_2d  ! [m^2]
  REAL(DP), DIMENSION(kproma, nlev, ngpblks),   SAVE :: grmass       ! [kg]

! **********************************************************************+
END MODULE messy_main_data_si
! **********************************************************************+
